



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Gson解决字段为空是报错的问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Gson解决字段为空是报错的问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 08:49:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p>json解析有很多工具，这里说的是最常用也是解析速度最快的Gson，Gson是google家出的，有一个缺点就是无法设置null替换，<br />
我们只能手动的批量替换服务器返回的null了，正常的接口定义的时候是绝对不允许服务器返回null的，后台结果却总会出现null！<br />
如果搜索的话有一个常见的答案，<br />
<code>Gson gson = new GsonBuilder().serializeNulls().create();</code><br />
但是这个却无法解决反序列问题,怎么解决呢？我在stackoverflow上找到了这个问题，亲测有效<br />
<a href="https://link.jianshu.com?t=http://stackoverflow.com/questions/9483348/gson-treat-null-as-empty-string/24252578#24252578" rel="external nofollow noreferrer">http://stackoverflow.com/questions/9483348/gson-treat-null-as-empty-string/24252578#24252578</a></p>
<p>解决办法如下：</p>
<pre class="prettyprint linenums"><code>Gson gson  = new GsonBuilder().registerTypeAdapterFactory(new NullStringToEmptyAdapterFactory()).create();<br />
//然后用上面一行写的gson来序列化和反序列化实体类type<br />
gson.fromJson(json, type);<br />
gson.toJson(type);<br />
</code></pre>
<p>//NullStringToEmptyAdapterFactory的代码</p>
<pre class="prettyprint linenums"><code>public class NullStringToEmptyAdapterFactory&lt;T&gt; implements TypeAdapterFactory {<br />
    @SuppressWarnings("unchecked")<br />
    public &lt;T&gt; TypeAdapter&lt;T&gt; create(Gson gson, TypeToken&lt;T&gt; type) {<br />
        Class&lt;T&gt; rawType = (Class&lt;T&gt;) type.getRawType();<br />
        if (rawType != String.class) {<br />
            return null;<br />
        }<br />
        return (TypeAdapter&lt;T&gt;) new StringNullAdapter();<br />
    }<br />
}<br />
</code></pre>
<p>// StringNullAdapter代码</p>
<pre class="prettyprint linenums"><code>public class StringNullAdapter extends TypeAdapter&lt;String&gt; {<br />
    @Override<br />
    public String read(JsonReader reader) throws IOException {<br />
        // TODO Auto-generated method stub<br />
        if (reader.peek() == JsonToken.NULL) {<br />
            reader.nextNull();<br />
            return "";<br />
        }<br />
        return reader.nextString();<br />
    }<br />
    @Override<br />
    public void write(JsonWriter writer, String value) throws IOException {<br />
        // TODO Auto-generated method stub<br />
        if (value == null) {<br />
            writer.nullValue();<br />
            return;<br />
        }<br />
        writer.value(value);<br />
    }<br />
}</code></pre>
</div>
<p>作者：hloong<br />链接：https://www.jianshu.com/p/c6dd9a6b10ee<br />來源：简书<br />著作权归作者所有。商业转载请联系作者获得授权，非商业转载请注明出处。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlmg69o.html">2&period;WindowsServer2012R2装完的一些友好化设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/390p4pn8.html">android 7&period;0变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkkdmq.html">【Remoting】&period;Net remoting方法实现简单的在线升级（上篇：更新文件）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2y1l38.html">用SQL语句添加删除修改字段&lowbar;常用SQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oex0x9.html">Ember Charts &ndash; 基于 Ember &amp;amp&semi; D3 的图表库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yy0d3q.html">&lbrack;转&rsqb;Web基础架构：负载均衡和LVS</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrn309.html">jQuery 常见操作实现方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1y2w28.html">org&period;apache&period;commons&period;dbutils&period;QueryRunner  执行sqlserver的存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/96olevj9.html">【css】web标准</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjoyo79.html">Qt 学习之路 ：Qt 模块简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy15m4mq.html">node项目的基本构建流程或者打开一个node项目的流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgm1dr8.html">Spark算子--union、intersection、subtract</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zozjkdq.html">一个C&num;程序员学习微信小程序路由的笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyn5ye9.html">idea启动TOMCAT html 乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwd338.html">AWS Add Key Pair to Elastic Beanstalk Instance 给EB实例加密钥</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1krmlq.html">MySQL 5&period;6 以上版本支持三种sql&lowbar;mode模式：ANSI、TRADITIONAL和STRICT&lowbar;TRANS&lowbar;TABLES。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2k64oq.html">Linux Shell自动交互&sol;人机交互的三种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7w2k8.html">hello2源代码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1r02eq.html">配置svn用户及权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zynp2d9.html">JVM的垃圾回收机制</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e45d0z9.html">MySql联合查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwdmzz9.html">Linux Shell脚本编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jmx73q.html">vue中过滤器filters的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ol4kg8.html">【ARTS】01&lowbar;20&lowbar;左耳听风-20190325~20190331</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7olpxj8.html">【转】shell速查表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7onmg18.html">svn服务器镜像备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv20vx19.html">线性回归&comma;逻辑回归&comma;神经网络&comma;SVM的总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rjk028.html">&lpar;并发编程&rpar;进程池线程池--提交任务2种方式&plus;（异步回调&rpar;、协程--yield关键字 greenlet &comma;gevent模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r50nyrq.html">HBase的replication原理及部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r50n0rq.html">java后台发送请求并获取返回值</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
